import { DeepClient, SerialOperation } from '@deep-foundation/deeplinks/imports/client';
/**
 * Gets insert serial operations for handle
 *
 * @example
```ts

```
 */
export declare function getHandleInsertSerialOperations(param: GetHandleInsertSerialOperations): Promise<(SerialOperation<"insert", "links"> | SerialOperation<"insert", "strings">)[]>;
export type GetHandleInsertSerialOperations = {
    /**
     * DeepClient instance
     */
    deep: DeepClient;
    linkIds?: {
        /**
         * Link id of the handle that will be inserted
         */
        handleLinkId?: number;
        /**
         * Link id of the contain that will be inserted
         */
        containLinkId?: number;
    };
    /**
     * Id of link that will be handled
     */
    triggerTypeLinkId: number;
    /**
     * Link where handle will be contained
     */
    containerLinkId?: number;
    /**
     * Contain type link id
     */
    containTypeLinkId?: number;
    /**
     * Value of contain link that will be inserted
     */
    containValue?: string;
    /**
     * Handle type link id
     */
    handleTypeLinkId: number;
    /**
     * Link id of the handler
     */
    handlerLinkId: number;
};
